/*		Segundo Trabalho APC	06/2002
	Pontificia Universidade Catolica - Campinas PUCC
		    
		    Engenharia de Computacao
		    
    Cesar Henrique kalllas	opensrc@gmx.net		RA: 02099224
    Daniel Figueiredo Machado	daniel.fm@uol.com.br	RA: 02508224

    escopo: Agenda de contatos com arquivo.
*/

#include <string.h>
#include <iostream.h>
#include <stdio.h>
#define MAX 50

struct AGENDA
{
char	nome	[MAX],
		endereco[MAX],
		cidade	[MAX],
		uf		[MAX],
		tf		[MAX],
		tm		[MAX],
		fax		[MAX],
		email	[MAX];
};

void novo				(struct AGENDA *,int *,int *)	;
void alterar			(struct AGENDA *,int,int)		;   
void gravar				(struct AGENDA *,int)			;	
void deletar			(struct AGENDA *,int *)			;      
void pesquisar_nome		(struct AGENDA *,int,int)		;
void pesquisar_cidade	(struct AGENDA *,int)			;  
void aumentar			(struct AGENDA *,int *,int *)	;
void le_arq				(struct AGENDA *,int *)			;
void obs				()								;

int main()
{
	int users=30,
		total_users=0,
		opcao,
		m;
	
	struct AGENDA *dados			;
	
	dados = new struct AGENDA[users];
	le_arq (dados,&total_users)		;

	do
	{
			cout << "\n\n\xC9" ; for(m=0;m<55;m++) cout << "\xCD" ;;		cout << "\xBB"	;
		cout << "\n\xBA\xDF           PROJETO FINAL LAB APC - AGENDA		\xBA\n"			;		
			cout << "\xCC" ; for(m=0;m<55;m++) cout << "\xCD" ; cout << "\xB9\n"			;
		cout <<	"\xBA	1. Incluir					\xBA\n"				;
		cout << "\xBA	2. alterar					\xBA\n"				;
		cout << "\xBA	3. Pesquisar					\xBA\n"			;
		cout << "\xBA	4. Consultar por nome				\xBA\n"		;
		cout << "\xBA	5. Listar por cidade				\xBA\n"		;
		cout << "\xBA	6. gravar a configurao atual			\xBA\n"	;
		cout << "\xBA	7. Observacoes gerais de uso			\xBA\n"	;
		cout << "\xBA	8. Sair da agenda				\xBA\n"			;
			cout << "\xCC" ; for(m=0;m<55;m++) cout << "\xCD" ;;		cout << "\xBC\n"	;
			cout << "\xCC  ";
		cin>>opcao;
		
		switch (opcao)
		{
		case 1 :	novo				(dados,&users,&total_users)	;	break;
		case 2 :	deletar				(dados,&total_users)		;	break;
		case 3 :	alterar				(dados,users,total_users)	;	break;
		case 4 :	pesquisar_nome		(dados,users,total_users)	;	break;
		case 5 :	pesquisar_cidade	(dados,total_users)			;	break;
		case 6 :	gravar				(dados,total_users)			;	break;
		case 7 :	obs					()							;	break;
		case 8 :													;	break;
		default:	cout << "\n\xDB\xDB Opcao invalida escolhida, tente novamente !\n"	;	break;
		}
	}
	while (opcao!=8);
}

void novo (struct AGENDA *dados,int *users,int *total_users)
{
	int aux=1,
		flag=0,
		alt,
		i,
		m;
	char   confirm;
	struct AGENDA incluir;
	
		cout << "\xC8" ; for(m=0;m<40;m++) cout << "\xCD" ;;		cout << "\xBB"	;
	cout <<"\n 1		INCLUIR NOVO CONTATO\n\n";
	cout << " Nome: "		;	cin.get();	cin.getline (incluir.nome,50)	 ;
	cout << " Endereco: "	;	cin.get();	cin.getline (incluir.endereco,80);
	cout << " Cidade: "		;	cin.get();	cin.getline (incluir.cidade,50)	 ;
	cout << " uf: "			;	cin.get();	cin.getline (incluir.uf,50)		 ;
	cout << " Tel Fixo: "	;	cin.get();	cin.getline (incluir.tf,50)		 ;
	cout << " Tel Movel: "	;	cin.get();	cin.getline (incluir.tm,50)		 ;
	cout << " Fax: "		;	cin.get();	cin.getline (incluir.fax,50)	 ;
	cout << " E-email: "	;	cin.get();	cin.getline (incluir.email,50)	 ;

	for (i=0;i<*users;i++)
	{
		aux=strcmp (dados[i].nome,incluir.nome);
		if (aux==0)
		{
			flag=1;
			i=*users;
		}
	}

	if (flag==1)
	{
		cout<<"Contato ja cadastrado !\nSe voce deseja alterar os AGENDA dele digite 1, caso contrario digite 2: ";
		cin>>alt;
		if (alt==1)
			alterar (dados,*users,*total_users);
	}
	else
	{
		cout<<"Voce tem certeza que deseja cadastrar esse contato? (S/N): ";
		cin>>confirm;
		if (confirm=='S' || confirm=='s')
		{
			dados[*total_users]=incluir;
			(*total_users)++;
		}
	}

	if((*total_users)==(*total_users))
		aumentar (dados,users,total_users);
}

void deletar (struct AGENDA *ctt,int *k)
{
	char confirm, nome[30];
	int i, aux=1, flag=0, pos, j;

	cout<<"Digite o nome do contato que voce deseja excluir: ";
	cin.get();
	cin.getline (nome,30);

	for (i=0;i<*k;i++)
	{
		aux=strcmp (ctt[i].nome,nome);
		if (aux==0)
		{
			flag=1;
			pos=i;
			i=*k;
		}
	}

	if (flag==1)
	{
		cout<<"Nome: "<<ctt[pos].nome<<endl;
		cout<<"Endereco: "<<ctt[pos].endereco<<endl;
		cout<<"Cidade: "<<ctt[pos].cidade<<endl;
		cout<<"uf: "<<ctt[pos].uf<<endl;
		cout<<"Telefone Fixo: "<<ctt[pos].tf<<endl;
		cout<<"Telefone Movel: "<<ctt[pos].tm<<endl;
		cout<<"Fax: "<<ctt[pos].fax<<endl;
		cout<<"E-email: "<<ctt[pos].email<<endl;

		cout<<"Voce tem certeza que deseja excluir esse contato? (S/N): ";
		cin>>confirm;

		if (confirm=='S' || confirm=='s')
		{
			(*k)--;
			for (j=i;j<*k;j++)
				ctt[j]=ctt[j+1];
		}
	}
	else
		cout<<"Contato nao cadastrado !";
}

void alterar (struct AGENDA *ctt,int l,int k)
{
	struct AGENDA incluir;
	char confirm, nome[30];
	int i, aux=1, flag=0, cad, pos;

	cout<<"Digite o nome do contato que voce deseja alterar: ";
	cin.get();
	cin.getline (nome,30);

	for (i=0;i<k;i++)
	{
		aux=strcmp (ctt[i].nome,nome);
		if (aux==0)
		{
			flag=1;
			pos=i;
			i=k;
		}
	}

	if (flag==1)
	{
		cout<<"Nome: "<<ctt[pos].nome<<endl;
		cout<<"Endereco: "<<ctt[pos].endereco<<endl;
		cout<<"Cidade: "<<ctt[pos].cidade<<endl;
		cout<<"uf: "<<ctt[pos].uf<<endl;
		cout<<"Telefone Fixo: "<<ctt[pos].tf<<endl;
		cout<<"Telefone Movel: "<<ctt[pos].tm<<endl;
		cout<<"Fax: "<<ctt[pos].fax<<endl;
		cout<<"E-email: "<<ctt[pos].email<<endl;

		cout<<"Voce tem certeza que deseja alterar os AGENDA desse contato? (S/N): ";
		cin>>confirm;

		if (confirm=='S' || confirm=='s')
		{
			cout<<"Endereco: ";
			cin.get();
			cin.getline (incluir.endereco,80);
			cout<<"Cidade: ";
			cin.get();
			cin.getline (incluir.cidade,20);
			cout<<"uf: ";
			cin.get();
			cin.getline (incluir.uf,2);
			cout<<"Telefone Fixo: ";
			cin.get();
			cin.getline (incluir.tf,15);
			cout<<"Telefone Movel: ";
			cin.get();
			cin.getline (incluir.tm,15);
			cout<<"Fax: ";
			cin.get();
			cin.getline (incluir.fax,15);
			cout<<"E-email: ";
			cin.get();
			cin.getline (incluir.email,25);

			cout<<"Voce tem certeza que deseja alterar esses AGENDA? (S/N): ";
			cin>>confirm;

			if (confirm=='S' || confirm=='s')
			{
				strcpy (ctt[pos].endereco,incluir.endereco);
				strcpy (ctt[pos].cidade,incluir.cidade);
				strcpy (ctt[pos].uf,incluir.uf);
				strcpy (ctt[pos].tf,incluir.tf);
				strcpy (ctt[pos].tm,incluir.tm);
				strcpy (ctt[pos].fax,incluir.fax);
				strcpy (ctt[pos].email,incluir.email);
			}
		}
	}
	else
	{
		cout<<"Contato nao cadastrado !\nSe voce deseja cadastra-lo digite 1, caso contrario digite 2: ";
		cin>>cad;
		if (cad==1)
			novo (ctt,&l,&k);
	}
}

void pesquisar_nome (struct AGENDA *ctt,int l,int k)
{
	int i, cad, pos, aux=1, flag=0;
	char nome[30];

	cout<<"Digite o nome a ser consultado: ";
	cin.get();
	cin.getline (nome,30);

	for (i=0;i<k;i++)
	{
		aux=strcmp (ctt[i].nome,nome);
		if (aux==0)
		{
			flag=1;
			pos=i;
			i=k;
		}
	}

	if (flag==1)
	{
		cout<<"Nome: "<<ctt[pos].nome<<endl;
		cout<<"Endereco: "<<ctt[pos].endereco<<endl;
		cout<<"Cidade: "<<ctt[pos].cidade<<endl;
		cout<<"uf: "<<ctt[pos].uf<<endl;
		cout<<"Telefone Fixo: "<<ctt[pos].tf<<endl;
		cout<<"Telefone Movel: "<<ctt[pos].tm<<endl;
		cout<<"Fax: "<<ctt[pos].fax<<endl;
		cout<<"E-email: "<<ctt[pos].email<<endl;
	}
	else
	{
		cout<<"Contato nao cadastrado !\nSe voce deseja cadastra-lo digite 1, caso contrario digite 2: ";
		cin>>cad;
		if (cad==1)
			novo (ctt,&l,&k);
	}
}
void pesquisar_cidade (struct AGENDA *ctt,int k)
{
	int i, aux=1;
	char cidade[20];

	cout<<"Digite o nome da cidade: ";
	cin.get();
	cin.getline (cidade,20);

	for (i=0;i<k;i++)
	{
		aux=strcmp (ctt[i].cidade,cidade);

		if (aux==0)
		{
			cout<<"Nome: "<<ctt[i].nome<<endl;
			cout<<"Telefones: "<<ctt[i].tf<<"  "<<ctt[i].tm<<"\n\n";
		}
	}
}

void gravar (struct AGENDA *ctt,int k)
{
	FILE* Arq;
	int i;

	Arq=fopen("R:\\Registro.dat","w");
	if (Arq==NULL)
		cout<<"Erro ao gravar os AGENDA !\n\n";
	else
	{
		for (i=0;i<k;i++)
		{
			fwrite(&ctt[i],sizeof(struct AGENDA),1,Arq);
			cout<<"AGENDA salvos com suceso !\n\n";
		}
	}
}

void le_arq (struct AGENDA *ctt,int *k)
{
	FILE* Arq;

	Arq=fopen("R:\\Registro.dat","r");
	*k=0;
	if (Arq==NULL)
	{	cout << "Falha em abrir o banco de dados ! \n\n";
		cout << "Caso seja a sua primeira vez em acessar esta agenda, desconsidere o erro\n";
	}
	else
	{

		while (!feof(Arq))
		{
			if (fread(&ctt[*k],sizeof(struct AGENDA),1,Arq) !=0)
			   (*k)++;
		}
	}
}

void aumentar (struct AGENDA *ctt,int *l,int *k)
{
	int i;
	(*l)*=1.25;
	struct AGENDA *aux;
	aux=new AGENDA [*l];
	
	for (i=0;i<*k;i++)
		aux[i]=ctt[i];

	delete[] ctt;
	ctt=aux;
}

void obs()
{ 
	cout << "   O preenchimento dos campos, na opcao incluir, deve conter,\n";
	cout << "no maximo 50 caracteres";
}
